#ifndef _UI_SCROLL_LIST_H_
#define _UI_SCROLL_LIST_H_

class UIScrollList {
public:
	UIScrollList (int new_start_x, int new_end_x,
		      int new_start_y, int new_end_y);
	~UIScrollList ();
	
	void init_list_size (int new_list_size);
	void init_item_add (const char *item);
	void init_render_list (void);

	void set_x_y (int new_start_x, int new_end_x,
		      int new_start_y, int new_end_y);

	void scroll_up (void);
	void scroll_down (void);
	void scroll_page_up (void);
	void scroll_page_down (void);
	
	const char *get_item (int number) const;
	const char *get_marked_item (void) const;
	int         get_marked_item_list_number (void) const;
	inline int  get_list_size (void) const { return list_size; }
private:
	char **list;
	int    list_size;

	int start_x;
	int end_x;
	int start_y;
	int end_y;

	void render_list (void);
	void render_mark (void);
	
	int mark_position;
	int mark_position_old;
	
	int first_visible;
};

#endif
