#ifndef _UI_H_
#define _UI_H_

#include <ncurses.h>

#include "view-dir.h"
#include "ui-scroll-list.h"

typedef enum {
	UI_INPUT_PLAY,
	UI_INPUT_PLAY_STOP,
	UI_INPUT_PLAY_NEXT,
	UI_INPUT_QUIT,
} UIInput;

class UI {
public:
	UI (const char *dir = "~");
	~UI ();
	
	UIInput input (void);

	char *get_filename (void) const;
	char *get_filename_next (void) const;
	void set_played_file (const char *pf = NULL);
	char *played_file_next (void);
	void render_played_file (void);
private:
	int cols, rows;
	
	/* We need to know the amount of dirs/files if we would like to
	 * request a sertain file from the scroll_list, since scroll
	 * list doesn't keep track on what's what.
	 */
	int dirs_size, files_size;
	
	/* Prints the current directory name in the upper left corner. */
	void render_dir_name (void);

	/* Provides us with directory contents. */
	ViewDir *view_dir;

	/* Scrolls whatever view_dir provided us with. */
	UIScrollList *scroll_list;

	char *played_file;
	int   played_file_list_nr;

	void render_advance (void);
	bool advance;

	bool is_stoped;
};

#endif
