#ifndef _VIEW_DIR_H_
#define _VIEW_DIR_H_

class ViewDir {
public:
	/* @file_pattern: A vector of file extensions (ex. ".bnk" ".bonk").
	 *                Files which has these extensions will be included 
	 *                in the 'files' array.
	 *                If @file_pattern is NULL, all files will be included.
	 *                The last element must be NULL.
	 */
	ViewDir (const char *new_working_dir = "~", 
		 const char **file_pattern = NULL);
	~ViewDir ();

	bool change_working_dir (const char *new_working_dir);

	char *get_working_dir (void) const;
	char *get_working_dir_short (void) const;

	inline const char **get_dirs (void) const { 
		return (const char **)dirs; 
	}
	inline const char **get_files (void) const { 
		return (const char **)files; 
	}
	inline int get_dirs_size  (void) const { 
		return dirs_size; 
	}
	inline int get_files_size (void) const { 
		return files_size; 
	}
private:
	bool read_working_dir (void);

	const char **file_pattern;

	char *working_dir;
	
	/* dirs/files[last] == NULL */
	char **dirs;
	char **files;
	int dirs_size;
	int files_size;
};

#endif
